diff -Nur ircd-hybrid-6.3.1/src/s_bsd.c ircd-hybrid-6-OpenSSL/src/s_bsd.c
--- ircd-hybrid-6.3.1/src/s_bsd.c	2002-02-06 06:56:12.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/src/s_bsd.c	2002-12-13 16:53:36.000000000 +0200
@@ -79,6 +79,11 @@
 #define INADDR_NONE ((unsigned int) 0xffffffff)
 #endif
 
+#ifdef ALLOW_SSL
+#include "ssl.h"
+struct SSL_comm_t SSL_serv;
+#endif
+
 extern struct sockaddr_in vserv;               /* defined in s_conf.c */
 
 const char* const NONB_ERROR_MSG   = "set_non_blocking failed for %s:%s"; 
@@ -115,6 +120,33 @@
 
 void init_netio(void)
 {
+#ifdef ALLOW_SSL
+	int err;
+
+	SSLUnsetAll (&SSL_serv);
+	SSLSetUsed (&SSL_serv);
+	SSL_load_error_strings();
+	SSLeay_add_ssl_algorithms();
+	SSL_serv.meth = SSLv23_server_method();
+	SSL_serv.ctx = SSL_CTX_new (SSL_serv.meth);
+	CHK_ERR (L_NOTICE);
+	if (err == -1 || CHK_NULL(SSL_serv.ctx))
+		SSLUnsetUsed (&SSL_serv);
+	SSL_CTX_use_certificate_file (SSL_serv.ctx, CERTF, SSL_FILETYPE_PEM);
+	CHK_ERR (L_NOTICE);
+	if (err == -1)
+		SSLUnsetUsed (&SSL_serv);
+	SSL_CTX_use_PrivateKey_file (SSL_serv.ctx, KEYF, SSL_FILETYPE_PEM);
+	CHK_ERR (L_NOTICE);
+	if (err == -1)
+		SSLUnsetUsed (&SSL_serv);
+	SSL_CTX_check_private_key (SSL_serv.ctx);
+	CHK_ERR (L_NOTICE);
+	if (err == -1)
+		SSLUnsetUsed (&SSL_serv);
+	if (!SSLIsUsed (&SSL_serv))
+		SSL_release_all (&SSL_serv);
+#endif
 #ifndef USE_POLL
   read_set  = &readSet;
   write_set = &writeSet;
@@ -279,6 +311,11 @@
 {
   int   retval;
 
+#ifdef ALLOW_SSL
+	if (SSLIsConn (cptr->ssl))
+		retval = SSL_write((SSL *)cptr->ssl->ssl, str, len);
+	else
+#endif
   retval = send(cptr->fd, str, len, 0);
   /*
   ** Convert WOULDBLOCK to a return of "0 bytes moved". This
@@ -351,6 +388,44 @@
     }
   
   SetHandshake(cptr);
+
+#ifdef ALLOW_SSL
+#ifdef NOT_SSLCLIENT
+ 	SSLUnsetExpected (cptr->ssl);
+#endif
+ 	if (SSLIsExpected (cptr->ssl)) {
+ 		int err;
+ 		log (L_DEBUG, "SSLconnection to a server - neogotiating...");
+ 		cptr->ssl->meth = SSLv23_client_method();
+ 		cptr->ssl->ctx = SSL_CTX_new (cptr->ssl->meth);
+ 		if (CHK_NULL (cptr->ssl->ctx))
+ 			goto finhs;
+ 		cptr->ssl->ssl = (SSL *) SSL_new (cptr->ssl->ctx);
+ 		SSLSetUsed (cptr->ssl);
+ 		if (err == -1)
+ 		{
+ 			SSL_release_all (cptr->ssl);
+ 			SSLUnsetUsed (cptr->ssl);
+ 			goto finhs;
+ 		}
+ 		SSL_set_fd ((SSL *) cptr->ssl->ssl, cptr->fd);
+reconn:
+ 		err = SSL_connect ((SSL *) cptr->ssl->ssl);
+ 		if (err == -1) {
+ 	                err = SSL_get_error((SSL *) cptr->ssl->ssl, err);
+         	        if (err == SSL_ERROR_WANT_READ ||
+                 		err == SSL_ERROR_WANT_WRITE) goto reconn;
+ 			SSL_release_all (cptr->ssl);
+ 			SSLUnsetUsed (cptr->ssl);
+ 			goto finhs;
+ 		}
+ 		SSLSetConn (cptr->ssl);
+ 		log (L_DEBUG, "SSLconnection to a server - succesful");
+ 	}
+finhs:
+ 	CHK_ERR (L_DEBUG);
+#endif
+
     if (!EmptyString(c_conf->passwd))
     {
       sendto_one(cptr, "PASS %s :TS", c_conf->passwd);
@@ -697,6 +772,14 @@
     }
   else
     ServerStats->is_ni++;
+
+#ifdef ALLOW_SSL
+         if (SSLIsConn (cptr->ssl))
+         {
+ 		SSL_release_all (cptr->ssl);
+ 		SSLUnsetAll (cptr->ssl);
+         }
+#endif
   
   if (-1 < cptr->fd) {
     flush_connections(cptr);
@@ -727,6 +810,7 @@
     cptr->listener = 0;
   }
 
+
   for (; highest_fd > 0; --highest_fd) {
     if (local[highest_fd])
       break;
@@ -778,6 +862,39 @@
   new_client->listener  = listener;
   ++listener->ref_count;
 
+#ifdef ALLOW_SSL
+ 	if (new_client->listener && SSLIsExpected (new_client->ssl) &&
+ 		SSLIsUsed (&SSL_serv) && PORTIsSSL (new_client->listener)) {
+ 		struct SSL_comm_t *cssl = new_client->ssl;
+ 		int err;
+ 		log (L_DEBUG, "Accepting connection from client on mixed or SSL port");
+ 		SSLUnsetPackLost (cssl);
+ 		log (L_DEBUG, "SSL accepting connection from a client...");
+ 		cssl->meth = SSL_serv.meth;
+ 		cssl->ctx = SSL_serv.ctx;
+ 		cssl->ssl = (SSL *) SSL_new (cssl->ctx);
+ 		if (CHK_NULL (cssl->ssl))
+ 			goto finlist;
+ 		SSLSetUsed (cssl);
+ 		SSL_set_fd ((SSL *) cssl->ssl, new_client->fd);
+reaccept:
+ 		err = SSL_accept ((SSL *) cssl->ssl);
+ 		if (err == -1) {
+ 			err = SSL_get_error((SSL *) cssl->ssl, err);
+ 			if (err == SSL_ERROR_WANT_READ ||
+ 				err == SSL_ERROR_WANT_WRITE) goto reaccept;
+ 			SSLSetPackLost (cssl);
+ 			goto finlist;
+ 		}
+ 		SSLSetConn (cssl);
+ 		log (L_DEBUG, "SSL connection accepted from a client");
+	}
+finlist:
+ 	if (PORTSSL (new_client->listener) && !SSLIsConn (new_client->ssl))
+ 		SSLSetDown (new_client->ssl);
+ 	CHK_ERR (L_DEBUG);
+#endif
+
 #ifdef HIDE_SERVERS_IPS
   if (!set_non_blocking(new_client->fd))
     report_error(NONB_ERROR_MSG, get_client_name(new_client, MASK_IP), errno);
@@ -852,8 +969,30 @@
   int done = 0;
   char *rb;
   if (!(IsPerson(cptr) && DBufLength(&cptr->recvQ) > SBSD_MAX_CLIENT)) {
-    errno = 0;
+#ifdef ALLOW_SSL
+	if (SSLIsConn (cptr->ssl))
+		length = SSL_read ((SSL *)cptr->ssl->ssl, readBuf, READBUF_SIZE);
+	else
+#endif
     length = recv(cptr->fd, readBuf, READBUF_SIZE, 0);
+    errno = 0;
+#ifdef ALLOW_SSL
+	if (SSLIsPackLost (cptr->ssl) && length >= 1) {
+		char tmpbuff[READBUF_SIZE];
+		SSL *cssl = cptr->ssl->ssl;
+		u16 tmpblen = 0;
+		SSLUnsetPackLost (cptr->ssl);
+		memset (tmpbuff, 0, READBUF_SIZE);
+		memcpy (tmpbuff, cssl->packet, cssl->packet_length);
+		tmpblen = cssl->packet_length;
+		if (READBUF_SIZE < (cssl->packet_length + length))
+			length = READBUF_SIZE - cssl->packet_length;
+		tmpblen += length;
+		memcpy (tmpbuff + cssl->packet_length, readBuf, length);
+		length = (int) tmpblen;
+		memcpy (readBuf, tmpbuff, tmpblen);
+	}
+#endif
     /*
      * If not ready, fake it so it isnt closed
      */
@@ -902,6 +1041,12 @@
      * it on the end of the receive queue and do it when its
      * turn comes around.
      */
+
+#ifdef ALLOW_SSL
+	if (SSLMustDown (cptr->ssl))
+ 		return exit_client(cptr, cptr, cptr, "Unsecured connection");
+#endif
+
     if (!dbuf_put(&cptr->recvQ, rb, length))
       return exit_client(cptr, cptr, cptr, "dbuf_put fail");
 
diff -Nur ircd-hybrid-6.3.1/src/s_conf.c ircd-hybrid-6-OpenSSL/src/s_conf.c
--- ircd-hybrid-6.3.1/src/s_conf.c	2002-02-17 07:58:13.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/src/s_conf.c	2002-12-13 16:36:09.000000000 +0200
@@ -2089,6 +2089,19 @@
         case 'P': /* listen port line */
         case 'p':
           aconf->status = CONF_LISTEN_PORT;
+#ifdef ALLOW_SSL
+		aconf->cnftype = PORT_MIXED;
+		break;
+	case 'Z':
+	case 'z':
+		aconf->status = CONF_LISTEN_PORT;
+		aconf->cnftype = PORT_SSL;
+		break;
+	case 'F':
+	case 'f':
+		aconf->status = CONF_LISTEN_PORT;
+		aconf->cnftype = PORT_PLAIN;
+#endif
           break;
 
         case 'Q': /* reserved nicks */
@@ -2279,9 +2292,15 @@
         {
           dontadd = 1;
           if((aconf->passwd[0] == '\0') || (aconf->passwd[0] == '*'))
+#ifdef ALLOW_SSL
+		add_listener(aconf->port, NULL, (u8) aconf->cnftype);
+	else
+		add_listener(aconf->port, (const char *)aconf->passwd, (u8) aconf->cnftype);
+#else
             add_listener(aconf->port, NULL );
           else
             add_listener(aconf->port, (const char *)aconf->passwd);
+#endif
         }
       else if(aconf->status & CONF_CLIENT_MASK)
         {
diff -Nur ircd-hybrid-6.3.1/src/s_serv.c ircd-hybrid-6-OpenSSL/src/s_serv.c
--- ircd-hybrid-6.3.1/src/s_serv.c	2002-04-16 01:38:22.000000000 +0300
+++ ircd-hybrid-6-OpenSSL/src/s_serv.c	2002-12-13 16:36:09.000000000 +0200
@@ -70,6 +70,9 @@
 #ifdef ZIP_LINKS
   { "ZIP",      CAP_ZIP },
 #endif
+#ifdef ALLOW_SSL
+  { "SSL",	CAP_SSL },
+#endif
   { "QS",       CAP_QS },
   { "EX",       CAP_EX },
   { "CHW",      CAP_CHW },
diff -Nur ircd-hybrid-6.3.1/src/ssl.c ircd-hybrid-6-OpenSSL/src/ssl.c
--- ircd-hybrid-6.3.1/src/ssl.c	1970-01-01 02:00:00.000000000 +0200
+++ ircd-hybrid-6-OpenSSL/src/ssl.c	2002-12-13 16:36:09.000000000 +0200
@@ -0,0 +1,21 @@
+#include "config.h"
+#ifdef ALLOW_SSL
+#include "ssl.h"
+#include "s_log.h"
+
+void SSL_release_all (struct SSL_comm_t *ssl)
+{
+	if (!ssl)
+		return;
+	if (!ssl->status)
+		return;
+	if (!SSLIsUsed (ssl))
+		return;
+	if (ssl->ssl)
+	{
+		SSL_shutdown (ssl->ssl);
+		SSL_free (ssl->ssl);
+	}
+	log (L_DEBUG, "SSL cache, cypher lists and etc. cleared successfuly");
+}
+#endif
